unit HiScoreTable;

interface

uses Windows, Messages, SysUtils, Variants, Classes, Controls, Dialogs, ExtCtrls, StdCtrls,
 ComCtrls, registry;

function HST_ReadTable(ID:string):boolean;
function CalculateControlBit_HST(str:string):integer;
function HST_CheckTable(ID:string):boolean;
procedure HST_WriteTable(ID:string);
procedure HST_ResetTable;
procedure HST_DisplayTable(var names_string,points_string:string);
procedure MoveDownFrom_HST(place:integer);
procedure HST_TableAddItem(name:string;points:integer);
procedure HST_DeleteTable(ID:string);

implementation

var imena,poeni:array[1..10] of String;
    kontrola:integer;

//this will read data from registry into variables
function HST_ReadTable(ID:string):boolean;
var reg:TRegistry;
    i:integer;
begin
Result:=false;
reg:=TRegistry.Create;
reg.RootKey:=HKEY_LOCAL_MACHINE;
  if reg.KeyExists('\Software\Avram\Delphi\HiScoreTable\'+ID+'\') then begin
    reg.OpenKey('\Software\Avram\Delphi\HiScoreTable\'+ID+'\',true);
    for i:=1 to 10 do begin
      imena[i]:=reg.ReadString('Name'+IntToStr(i));
      poeni[i]:=reg.ReadString('Points'+IntToStr(i));
    end;
    Result:=true;
  end;
end;

//function for calculating control bit of string, very powerful for validity checking
function CalculateControlBit_HST(str:string):integer;
var o:integer;
begin
result:=0; kontrola:=0;
 for o:=1 to Length(str) do begin
  kontrola:=kontrola+ord(str[o]);
 end;
result:=kontrola;
end;

//will check bit value
function HST_CheckTable(ID:string):boolean;
var i,z:integer;
    reg:TRegistry;
    predefined_bit_value,current_bit_value,tempstring:string;
begin
Result:=false;
reg:=TRegistry.Create;
reg.RootKey:=HKEY_LOCAL_MACHINE;
  if reg.KeyExists('\Software\Avram\Delphi\HiScoreTable\'+ID+'\') then begin
    reg.OpenKeyReadOnly('\Software\Avram\Delphi\HiScoreTable\'+ID+'\');
    predefined_bit_value:=reg.ReadString('BitValue');
    tempstring:='';
    for i:=1 to 10 do begin
        tempstring:=tempstring+reg.ReadString('Name'+IntToStr(i));
        tempstring:=tempstring+reg.ReadString('Points'+IntToStr(i));
    end;
    tempstring:=tempstring+reg.ReadString('About');
    z:=CalculateControlBit_HST(tempstring);
    current_bit_value:=IntToStr(z);
    if current_bit_value=predefined_bit_value then Result:=true;
  end;
end;


//this will write table into registry
procedure HST_WriteTable(ID:string);
var reg:TRegistry;
    i,z:Integer;
    tempstring,bitn:String;
begin
tempstring:='';
reg:=TRegistry.Create;
reg.RootKey:=HKEY_LOCAL_MACHINE;
reg.OpenKey('\Software\Avram\Delphi\HiScoreTable\'+ID+'\',true);
  for i:=1 to 10 do begin
    reg.WriteString('Name'+inttostr(i),imena[i]);
    reg.WriteString('Points'+IntToStr(i),poeni[i]);
    tempstring:=tempstring+imena[i];
    tempstring:=tempstring+poeni[i];
  end;
tempstring:=tempstring+'HiScoreTable by Avram, avramyu@yahoo.com';
z:=CalculateControlBit_HST(tempstring);
bitn:=IntToStr(z);
reg.WriteString('BitValue',bitn);
reg.WriteString('About','HiScoreTable by Avram, avramyu@yahoo.com');
end;

//this EnaBle* user to reset table
procedure HST_ResetTable;
var i:integer;
    tempstring:string;
begin
tempstring:='';
  for i:=1 to 10 do begin
    imena[i]:='[none]';
    poeni[i]:='0';
  end;
end;

//dis will display names in one, and points in second string
procedure HST_DisplayTable(var names_string,points_string:string);
var i:integer;
begin
names_string:='';
points_string:='';
  for i:=1 to 10 do begin
    names_string:=names_string+imena[i]+#13#10;
    points_string:=points_string+poeni[i]+#13#10;
  end;
end;

//this function should move all down from curr. number
procedure MoveDownFrom_HST(place:integer);
var i:integer;
begin
if place>1 then begin

  for i:=10 downto place+1 do begin
    imena[i]:=imena[i-1];
    poeni[i]:=poeni[i-1];
  end;

end else begin

  for i:=10 downto 2 do begin
    imena[i]:=imena[i-1];
    poeni[i]:=poeni[i-1];
  end;

end;

end;

//last procedure, the hardest - adding
procedure HST_TableAddItem(name:string;points:integer);
var pojeni:string;
begin
pojeni:=IntToStr(points);

//1st
  if points>strtoint(poeni[1]) then begin
    MoveDownFrom_HST(1);
    poeni[1]:=pojeni;
    imena[1]:=name; exit;
  end;
//2nd
  if points>strtoint(poeni[2]) then begin
    MoveDownFrom_HST(2);
    poeni[2]:=pojeni;
    imena[2]:=name; exit;
  end;
//3rd
  if points>strtoint(poeni[3]) then begin
    MoveDownFrom_HST(3);
    poeni[3]:=pojeni;
    imena[3]:=name; exit;
  end;
//4th
  if points>strtoint(poeni[4]) then begin
    MoveDownFrom_HST(4);
    poeni[4]:=pojeni;
    imena[4]:=name; exit;
  end;
//5th
  if points>strtoint(poeni[5]) then begin
    MoveDownFrom_HST(5);
    poeni[5]:=pojeni;
    imena[5]:=name; exit;
  end;
//6th
  if points>strtoint(poeni[6]) then begin
    MoveDownFrom_HST(6);
    poeni[6]:=pojeni;
    imena[6]:=name; exit;
  end;
//7th
  if points>strtoint(poeni[7]) then begin
    MoveDownFrom_HST(7);
    poeni[7]:=pojeni;
    imena[7]:=name; exit;
  end;
//8th
  if points>strtoint(poeni[8]) then begin
    MoveDownFrom_HST(8);
    poeni[8]:=pojeni;
    imena[8]:=name; exit;
  end;
//9th
  if points>strtoint(poeni[9]) then begin
    MoveDownFrom_HST(9);
    poeni[9]:=pojeni;
    imena[9]:=name; exit;
  end;
//10th
  if points>strtoint(poeni[10]) then begin
    MoveDownFrom_HST(10);
    poeni[10]:=pojeni;
    imena[10]:=name; exit;
  end;

end;

procedure HST_DeleteTable(ID:string);
var reg:TRegistry;
begin
reg:=TRegistry.Create;
reg.RootKey:=HKEY_LOCAL_MACHINE;
reg.DeleteKey('\Software\Avram\Delphi\HiScoreTable\'+ID+'\');
end;

//* - EB, from EYESBURN, http://www.eyesburn.co.sr/
end.
